#!/usr/bin/python
# -*- coding: utf-8 -*-

import platform, sys

class EkdPrint(object):
	""" Classe pour gérer les print sous python 2 et 3 """

	def __init__(self, texte):
	  
		from moteur_modules_common.EkdConfig import EkdConfig

		# Texte qui sera affiché
		self.texte = texte.encode(EkdConfig.coding)
		
		# Affichage selon les versions de Python
		if platform.python_version()[0] == '2': print self.texte.decode(EkdConfig.coding)
		elif platform.python_version()[0] == '3': print(self.texte.decode(EkdConfig.coding))
		
		
class EkdInput(object):
	""" Classe pour gérer le input sous python 2 et 3 dans ekd_outils_traduction.py.
	Dans ekd_outils_traduction.py, la valeur sera à récupérer par if choix.valeur == n"""

	def __init__(self, valeur):

		# Texte qui sera affiché
		self.valeur = valeur.encode(sys.stdout.encoding)
		
		# Affichage selon les versions de Python
		if platform.python_version()[0] == '2': 
			self.valeur = input(self.valeur)
		elif platform.python_version()[0] == '3': 
			self.valeur = eval(input(self.valeur))


class EkdRawInput(object):
	""" Classe pour gérer le raw_input sous python 2 et 3 dans ekd_outils_traduction.py"""

	def __init__(self, texte):

		# Texte qui sera affiché
		self.texte = texte.encode(sys.stdout.encoding)
		
		# Affichage selon les versions de Python
		if platform.python_version()[0] == '2': 
			self.texte = raw_input(self.texte)
		elif platform.python_version()[0] == '3': 
			self.texte = input(self.texte)
			
			
class EkdPrintConfig(object):
	""" Classe pour gérer les print sous python 2 et 3. Cette classe a été crés 
	particulièrement pour être utilisée pour moteur_modules_common/EkdConfig.py
	car la classe EkdPrint définie ici plus haut utilise EkdConfig lui-même pour 
	l'encodage, ce qui pose bien sûr un problème dans EkdConfig.py lui-même ! """

	def __init__(self, texte):

		# Texte qui sera affiché
		self.texte = texte
		
		# Affichage selon les versions de Python
		if platform.python_version()[0] == '2': print self.texte
		elif platform.python_version()[0] == '3': print(self.texte)
